# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrganizationalUnitDescendantOrganizationalUnitsResult',
    'AwaitableGetOrganizationalUnitDescendantOrganizationalUnitsResult',
    'get_organizational_unit_descendant_organizational_units',
    'get_organizational_unit_descendant_organizational_units_output',
]

@pulumi.output_type
class GetOrganizationalUnitDescendantOrganizationalUnitsResult:
    """
    A collection of values returned by getOrganizationalUnitDescendantOrganizationalUnits.
    """
    def __init__(__self__, childrens=None, id=None, parent_id=None):
        if childrens and not isinstance(childrens, list):
            raise TypeError("Expected argument 'childrens' to be a list")
        pulumi.set(__self__, "childrens", childrens)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if parent_id and not isinstance(parent_id, str):
            raise TypeError("Expected argument 'parent_id' to be a str")
        pulumi.set(__self__, "parent_id", parent_id)

    @property
    @pulumi.getter
    def childrens(self) -> Sequence['outputs.GetOrganizationalUnitDescendantOrganizationalUnitsChildrenResult']:
        """
        List of child organizational units, which have the following attributes:
        """
        return pulumi.get(self, "childrens")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="parentId")
    def parent_id(self) -> str:
        return pulumi.get(self, "parent_id")


class AwaitableGetOrganizationalUnitDescendantOrganizationalUnitsResult(GetOrganizationalUnitDescendantOrganizationalUnitsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationalUnitDescendantOrganizationalUnitsResult(
            childrens=self.childrens,
            id=self.id,
            parent_id=self.parent_id)


def get_organizational_unit_descendant_organizational_units(parent_id: Optional[str] = None,
                                                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationalUnitDescendantOrganizationalUnitsResult:
    """
    Get all direct child organizational units under a parent organizational unit. This provides all children.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    org = aws.organizations.get_organization()
    ous = aws.organizations.get_organizational_unit_descendant_organizational_units(parent_id=org.roots[0].id)
    ```


    :param str parent_id: Parent ID of the organizational unit.
    """
    __args__ = dict()
    __args__['parentId'] = parent_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws:organizations/getOrganizationalUnitDescendantOrganizationalUnits:getOrganizationalUnitDescendantOrganizationalUnits', __args__, opts=opts, typ=GetOrganizationalUnitDescendantOrganizationalUnitsResult).value

    return AwaitableGetOrganizationalUnitDescendantOrganizationalUnitsResult(
        childrens=pulumi.get(__ret__, 'childrens'),
        id=pulumi.get(__ret__, 'id'),
        parent_id=pulumi.get(__ret__, 'parent_id'))
def get_organizational_unit_descendant_organizational_units_output(parent_id: Optional[pulumi.Input[str]] = None,
                                                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOrganizationalUnitDescendantOrganizationalUnitsResult]:
    """
    Get all direct child organizational units under a parent organizational unit. This provides all children.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    org = aws.organizations.get_organization()
    ous = aws.organizations.get_organizational_unit_descendant_organizational_units(parent_id=org.roots[0].id)
    ```


    :param str parent_id: Parent ID of the organizational unit.
    """
    __args__ = dict()
    __args__['parentId'] = parent_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws:organizations/getOrganizationalUnitDescendantOrganizationalUnits:getOrganizationalUnitDescendantOrganizationalUnits', __args__, opts=opts, typ=GetOrganizationalUnitDescendantOrganizationalUnitsResult)
    return __ret__.apply(lambda __response__: GetOrganizationalUnitDescendantOrganizationalUnitsResult(
        childrens=pulumi.get(__response__, 'childrens'),
        id=pulumi.get(__response__, 'id'),
        parent_id=pulumi.get(__response__, 'parent_id')))
